/*
** HDL4SE: VerilogۺϷƽ̨
** Copyright (C) 2021-2021, raoxianhong<raoxianhong@163.net>
** LCOM: ģ
** Copyright (C) 2021-2021, raoxianhong<raoxianhong@163.net>
** All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are met:
**
** * Redistributions of source code must retain the above copyright notice,
**   this list of conditions and the following disclaimer.
** * Redistributions in binary form must reproduce the above copyright notice,
**   this list of conditions and the following disclaimer in the documentation
**   and/or other materials provided with the distribution.
** * The name of the author may be used to endorse or promote products
**   derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
** AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
** IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
** ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
** LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
** THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
* hdl4se_module.c
  ޸ļ¼
	202105180851: rxh, initial version
*/
#include "stdlib.h" 
#include "stdio.h"
#include "object.h"
#include "dlist.h"
#include "bignumber.h"
#include "hdl4secell.h"


/* 
HDL4SE_MODULE 
instance parameter: "8", width=8
*/
typedef struct _sHDL4SEModule {
	OBJECT_HEADER
	INTERFACE_DECLARE(IHDL4SEModule)
	HDL4SEMODULE_VARDECLARE
	INTERFACE_DECLARE(IHDL4SEUnit)
	HDL4SEUNIT_VARDECLARE
	DLIST_VARDECLARE
	
	IHDL4SEModule** parent;
	char* name;

}sHDL4SEModule;

OBJECT_FUNCDECLARE(hdl4se_module, CLSID_HDL4SE_MODULE);
HDL4SEUNIT_FUNCDECLARE(hdl4se_module, CLSID_HDL4SE_MODULE, sHDL4SEModule);
HDL4SEMODULE_FUNCDECLARE(hdl4se_module, CLSID_HDL4SE_MODULE, sHDL4SEModule);
HDL4SEUNIT_FUNCIMPL(hdl4se_module, CLSID_HDL4SE_MODULE, sHDL4SEModule);
DLIST_FUNCIMPL(hdl4se_module, CLSID_HDL4SE_MODULE, sHDL4SEModule);

OBJECT_FUNCIMPL(hdl4se_module, sHDL4SEModule, CLSID_HDL4SE_MODULE);


QUERYINTERFACE_BEGIN(hdl4se_module, CLSID_HDL4SE_MODULE)
QUERYINTERFACE_ITEM(IID_HDL4SEUNIT, IHDL4SEUnit, sHDL4SEModule)
QUERYINTERFACE_ITEM(IID_DLIST, IDList, sHDL4SEModule)
QUERYINTERFACE_ITEM(IID_HDL4SEMODULE, IHDL4SEModule, sHDL4SEModule)
QUERYINTERFACE_END

static const char* hdl4se_moduleModuleInfo()
{
	return "1.0.0-20210521.1754 HDL4SE Module cell";
}

static int hdl4se_moduleCreate(const PARAMITEM* pParams, int paramcount, HOBJECT* pObject)
{
	sHDL4SEModule* pobj;
	int i;
	pobj = (sHDL4SEModule*)malloc(sizeof(sHDL4SEModule));
	if (pobj == NULL)
		return -1;
	*pObject = 0;
	HDL4SEUNIT_VARINIT(pobj, CLSID_HDL4SE_MODULE);
	INTERFACE_INIT(IHDL4SEUnit, pobj, hdl4se_module, hdl4se_unit);
	DLIST_VARINIT(pobj, hdl4se_module);
	
	pobj->name = NULL;
	pobj->parent = NULL;

	for (i = 0; i < paramcount; i++) {
		if (pParams[i].name == PARAMID_HDL4SE_UNIT_NAME) {
			if (pobj->name != NULL)
				free(pobj->name);
			pobj->name = strdup(pParams[i].pvalue);
		} 
		else if (pParams[i].name == PARAMID_HDL4SE_UNIT_PARENT) {
			pobj->parent = (IHDL4SEModule **)pParams[i].pvalue;
		}
		else if (pParams[i].name == PARAMID_HDL4SE_UNIT_INSTANCE_PARAMETERS) {
		}
	}


	/* ɵĶ */
	OBJECT_RETURN_GEN(hdl4se_module, pobj, pObject, CLSID_HDL4SE_MODULE);
	return EIID_OK;
}

static void hdl4se_moduleDestroy(HOBJECT object)
{
	sHDL4SEModule* pobj;
	pobj = (sHDL4SEModule*)objectThis(object);
	if (pobj->name != NULL)
		free(pobj->name);
	memset(pobj, 0, sizeof(sHDL4SEModule));
	free(pobj);
}

static int hdl4se_moduleValid(HOBJECT object)
{
	sHDL4SEModule* pobj;
	pobj = (sHDL4SEModule*)objectThis(object);
	return 1;
}

static int hdl4se_module_hdl4se_unit_Connect(HOBJECT object, int index, HOBJECT from, int fromindex) 
{
	sHDL4SEModule* pobj;
	IHDL4SEUnit** unit = NULL;
	pobj = (sHDL4SEModule*)objectThis(object);
/*
	if (index == 0) {
		if (0 == objectQueryInterface(from, IID_HDL4SEUNIT, (void**)&unit)) {
			objectRelease(pobj->sel);
			pobj->sel = unit;
			pobj->sel_index = fromindex;
		}
		else {
			return -2;
		}
	}
	else if (index >= 1 && index <= 2) {
		if (0 == objectQueryInterface(from, IID_HDL4SEUNIT, (void**)&unit)) {
			objectRelease(pobj->in[index-1]);
			pobj->in[index-1] = unit;
			pobj->in_index[index-1] = fromindex;
		}
		else {
			return -2;
		}
	}
	else {
		return -1;
	}
*/
	return 0;
}

static int hdl4se_module_hdl4se_unit_GetValue(HOBJECT object, int index, int width, IBigNumber ** value)
{
	int i;
	int sel;
	sHDL4SEModule* pobj;
	pobj = (sHDL4SEModule*)objectThis(object);
/*
	if (index != 3)
		return -1;
	objectCall3(pobj->sel, GetValue, pobj->sel_index, 1, pobj->in_sel);
	objectCall1(pobj->in_sel, GetInt, &sel);
	if (sel >= 0 && sel <= 1) {
		objectCall3(pobj->in[sel], GetValue, pobj->in_index[sel], pobj->width, pobj->out_data);
	}
	else {
		return -2;
	}
	//objectCall(pobj->out_data, SetBitscount, width);
	objectCall1(value, Assign, pobj->out_data);
	hdl4se_module_hdl4se_unit_SetFuncSet(object, 1);
*/	
	return 0;
}

static int hdl4se_module_hdl4se_unit_GetValueStored(HOBJECT object, int index, int width, IBigNumber** value)
{
	sHDL4SEModule* pobj;
	pobj = (sHDL4SEModule*)objectThis(object);
/*
	if (index != 3)
		return -1;
	objectCall1(value, Assign, pobj->out_data);
	//objectCall(value, SetBitscount, width);
*/
	return 0;
}

static int hdl4se_module_hdl4se_unit_ClkTick(HOBJECT object)
{
	sHDL4SEModule* pobj;
	pobj = (sHDL4SEModule*)objectThis(object);
	return 0;
}

static int hdl4se_module_hdl4se_unit_Setup(HOBJECT object)
{
	sHDL4SEModule* pobj;
	pobj = (sHDL4SEModule*)objectThis(object);
	hdl4se_module_hdl4se_unit_SetFuncSet(object, 0);
	return 0;
}

static int hdl4se_module_hdl4se_module_AddPort(HOBJECT object, int width, int type, const char* name)
{
	sHDL4SEModule* pobj;
	pobj = (sHDL4SEModule*)objectThis(object);
	return 0;
}

static int hdl4se_module_hdl4se_module_AddUnit(HOBJECT object, IHDL4SEUnit ** unit, const char * name)
{
	sHDL4SEModule* pobj;
	pobj = (sHDL4SEModule*)objectThis(object);
	return 0;
}

